## lighttpd 1.4.56~rc7

=== CMakeLists.txt ===
project(lighttpd C)

cmake_minimum_required(VERSION 2.8.2 FATAL_ERROR)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/scripts/cmake)

include(CTest)

enable_testing()

set(CPACK_PACKAGE_VERSION_MAJOR 1)
set(CPACK_PACKAGE_VERSION_MINOR 4)
set(CPACK_PACKAGE_VERSION_PATCH 56)
set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README")
set(CPACK_PACKAGE_VENDOR "jan@kneschke.de")

set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES "/\\\\.;~$;/_;build/;CMakeFiles/;CMakeCache;gz$;Makefile\\\\.;trace;Testing/;foo;autom4te;cmake_install;CPack;\\\\.pem;ltmain.sh;configure;libtool;/config\\\\.;missing;autogen.sh;install-sh;Dart;aclocal;log$;Makefile$")

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

add_subdirectory(src build)
#add_subdirectory(doc)
add_subdirectory(tests)

=== SConstruct ===
from __future__ import print_function
import os
import re
import string
import sys
from copy import copy
from stat import *

try:
	string_types = basestring
except NameError:
	string_types = str

package = 'lighttpd'
version = '1.4.56'

underscorify_reg = re.compile('[^A-Z0-9]')
def underscorify(id):
	return underscorify_reg.sub('_', id.upper())

def fail(*args, **kwargs):
	print(*args, file=sys.stderr, **kwargs)
	sys.exit(-1)

class Autoconf:
	class RestoreEnvLibs:
		def __init__(self, env):
			self.env = env
			self.active = False

		def __enter__(self):
			if self.active:
				raise Exception('entered twice')
			self.active = True
			if 'LIBS' in self.env:
				#print("Backup LIBS: " + repr(self.env['LIBS']))
				self.empty = False
				self.backup_libs = copy(self.env['LIBS'])
			else:
				#print("No LIBS to backup")
				self.empty = True

		def __exit__(self, type, value, traceback):
			if not self.active:
				raise Exception('exited twice')
			self.active = False
			if self.empty:
				if 'LIBS' in self.env:
					del self.env['LIBS']
			else:
				#print("Restoring LIBS, now: " + repr(self.env['LIBS']))
				self.env['LIBS'] = self.backup_libs
				#print("Restoring LIBS, to: " + repr(self.env['LIBS']))

	def __init__(self, env):
		self.conf = Configure(env, custom_tests = {
			'CheckGmtOffInStructTm': Autoconf.__checkGmtOffInStructTm,
			'CheckIPv6': Autoconf.__checkIPv6,
			'CheckWeakSymbols': Autoconf.__checkWeakSymbols,
		})

	def append(self, *args, **kw):
		return self.conf.env.Append(*args, **kw)

	def Finish(self):
		return self.conf.Finish()

	@property
	def env(self):
		return self.conf.env

	def restoreEnvLibs(self):
		return Autoconf.RestoreEnvLibs(self.conf.env)

	def CheckType(self, *args, **kw):
		return self.conf.CheckType(*args, **kw)

	def CheckLib(self, *args, **kw):
		return self.conf.CheckLib(*args, autoadd = 0, **kw)

	def CheckLibWithHeader(self, *args, **kw):
		return self.conf.CheckLibWithHeader(*args, autoadd = 0, **kw)

	def CheckGmtOffInStructTm(self):
		return self.conf.CheckGmtOffInStructTm()

	def CheckIPv6(self):
		return self.conf.CheckIPv6()

	def CheckWeakSymbols(self):
		return self.conf.CheckWeakSymbols()

	def CheckCHeader(self, hdr):
		return self.conf.CheckCHeader(hdr)

	def haveCHeader(self, hdr):
		if self.CheckCHeader(hdr):
			# if we have a list of headers define HAVE_ only for last one
			target = hdr
			if not isinstance(target, string_types):
				target = target[-1]
			self.conf.env.Append(CPPFLAGS = [ '-DHAVE_' + underscorify(target) ])
			return True
		return False

	def haveCHeaders(self, hdrs):
		for hdr in hdrs:
			self.haveCHeader(hdr)

	def CheckFunc(self, func, header = None, libs = []):
		with self.restoreEnvLibs():
			self.env.Append(LIBS = libs)
			return self.conf.CheckFunc(func, header = header)

	def CheckFuncInLib(self, func, lib):
		return self.CheckFunc(func, libs = [lib])

	def haveFuncInLib(self, func, lib):
		if self.CheckFuncInLib(func, lib):
			self.conf.env.Append(CPPFLAGS = [ '-DHAVE_' + underscorify(func) ])
			return True
		return False

	def haveFunc(self, func, header = None, libs = []):
		if self.CheckFunc(func, header = header, libs = libs):
			self.conf.env.Append(CPPFLAGS = [ '-DHAVE_' + underscorify(func) ])
			return True
		return False

	def haveFuncs(self, funcs):
		for func in funcs:
			self.haveFunc(func)

	def haveTypes(self, types):
		for type in types:
			if self.conf.CheckType(type, '#include <sys/types.h>'):
				self.conf.env.Append(CPPFLAGS = [ '-DHAVE_' + underscorify(type) ])

	def CheckParseConfig(self, *args, **kw):
		try:
			self.conf.env.ParseConfig(*args, **kw)
			return True
		except Exception as e:
			print(e.message, file=sys.stderr)
			return False

	def CheckParseConfigForLib(self, lib, *args, **kw):
		with self.restoreEnvLibs():
			self.env['LIBS'] = []
			if not self.CheckParseConfig(*args, **kw):
				return False
			self.env.Append(**{lib: self.env['LIBS']})
			return True

	@staticmethod
	def __checkGmtOffInStructTm(context):
		source = """
#include <time.h>
int main() {
	struct tm a;
	a.tm_gmtoff = 0;
	return 0;
}
"""
		context.Message('Checking for tm_gmtoff in struct tm...')
		result = context.TryLink(source, '.c')
		context.Result(result)

		return result

	@staticmethod
	def __checkIPv6(context):
		source = """
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

int main() {
	struct sockaddr_in6 s; struct in6_addr t=in6addr_any; int i=AF_INET6; s; t.s6_addr[0] = 0;
	return 0;
}
"""
		context.Message('Checking for IPv6 support...')
		result = context.TryLink(source, '.c')
		context.Result(result)

		return result

	@staticmethod
	def __checkWeakSymbols(context):
		source = """
__attribute__((weak)) void __dummy(void *x) { }
int main() {
	void *x;
	__dummy(x);
}
"""
		context.Message('Checking for weak symbol support...')
		result = context.TryLink(source, '.c')
		context.Result(result)

		return result

	def checkProgram(self, withname, progname):
		withname = 'with_' + withname
		binpath = None

		if self.env[withname] != 1:
			binpath = self.env[withname]
		else:
			prog = self.env.Detect(progname)
			if prog:
				binpath = self.env.WhereIs(prog)

		if binpath:
			mode = os.stat(binpath)[ST_MODE]
			if S_ISDIR(mode):
				fail("* error: path `%s' is a directory" % (binpath))
			if not S_ISREG(mode):
				fail("* error: path `%s' is not a file or not exists" % (binpath))

		if not binpath:
			fail("* error: can't find program `%s'" % (progname))

		return binpath

VariantDir('sconsbuild/build', 'src', duplicate = 0)
VariantDir('sconsbuild/tests', 'tests', duplicate = 0)

vars = Variables()
vars.AddVariables(
	('prefix', 'prefix', '/usr/local'),
	('bindir', 'binary directory', '${prefix}/bin'),
	('sbindir', 'binary directory', '${prefix}/sbin'),
	('libdir', 'library directory', '${prefix}/lib'),
	PathVariable('CC', 'path to the c-compiler', None),
	BoolVariable('build_dynamic', 'enable dynamic build', 'yes'),
	BoolVariable('build_static', 'enable static build', 'no'),
	BoolVariable('build_fullstatic', 'enable fullstatic build', 'no'),

	BoolVariable('with_bzip2', 'enable bzip2 compression', 'no'),
	BoolVariable('with_brotli', 'enable brotli compression', 'no'),
	PackageVariable('with_dbi', 'enable dbi support', 'no'),
	BoolVariable('with_fam', 'enable FAM/gamin support', 'no'),
	BoolVariable('with_gdbm', 'enable gdbm support', 'no'),
	BoolVariable('with_geoip', 'enable GeoIP support', 'no'),
	BoolVariable('with_maxminddb', 'enable MaxMind GeoIP2 support', 'no'),
	BoolVariable('with_krb5', 'enable krb5 auth support', 'no'),
	BoolVariable('with_ldap', 'enable ldap auth support', 'no'),
	# with_libev not supported
	# with_libunwind not supported
	BoolVariable('with_lua', 'enable lua support for mod_cml', 'no'),
	BoolVariable('with_memcached', 'enable memcached support', 'no'),
	PackageVariable('with_mysql', 'enable mysql support', 'no'),
	BoolVariable('with_openssl', 'enable openssl support', 'no'),
	PackageVariable('with_gnutls', 'enable GnuTLS support', 'no'),
	PackageVariable('with_mbedtls', 'enable mbedTLS support', 'no'),
	PackageVariable('with_nss', 'enable NSS crypto support', 'no'),
	PackageVariable('with_wolfssl', 'enable wolfSSL support', 'no'),
	BoolVariable('with_nettle', 'enable Nettle support', 'no'),
	BoolVariable('with_pam', 'enable PAM auth support', 'no'),
	PackageVariable('with_pcre', 'enable pcre support', 'yes'),
	PackageVariable('with_pgsql', 'enable pgsql support', 'no'),
	PackageVariable('with_sasl', 'enable SASL support', 'no'),
	BoolVariable('with_sqlite3', 'enable sqlite3 support (required for webdav props)', 'no'),
	BoolVariable('with_uuid', 'enable uuid support (required for webdav locks)', 'no'),
	# with_valgrind not supported
	# with_xattr not supported
	PackageVariable('with_xml', 'enable xml support (required for webdav props)', 'no'),
	BoolVariable('with_xxhash', 'build with system-provided xxhash', 'no'),
	BoolVariable('with_zlib', 'enable deflate/gzip compression', 'no'),

	BoolVariable('with_all', 'enable all with_* features', 'no'),
)

env = Environment(
	ENV = dict(os.environ),  # make sure we have a dict here so .Clone() works properly
	variables = vars,
	CPPPATH = Split('#sconsbuild/build')
)

env.Help(vars.GenerateHelpText(env))

if env.subst('${CC}') != '':
	env['CC'] = env.subst('${CC}')

env['package'] = package
env['version'] = version
if env['CC'] == 'gcc':
	## we need x-open 6 and bsd 4.3 features
	env.Append(CCFLAGS = Split('-Wall -O2 -g -W -pedantic -Wunused -Wshadow -std=gnu99'))

env.Append(CPPFLAGS = [
	'-D_FILE_OFFSET_BITS=64',
	'-D_LARGEFILE_SOURCE',
	'-D_LARGE_FILES',
	'-D_GNU_SOURCE',
])

if env['with_all']:
	for feature in vars.keys():
		# only enable 'with_*' flags
		if not feature.startswith('with_'): continue
		# don't overwrite manual arguments
		if feature in vars.args: continue
		# now activate
		env[feature] = True

# cache configure checks
if 1:
	autoconf = Autoconf(env)

	if 'CFLAGS' in os.environ:
		autoconf.env.Append(CCFLAGS = os.environ['CFLAGS'])
		print(">> Appending custom build flags : " + os.environ['CFLAGS'])

	if 'LDFLAGS' in os.environ:
		autoconf.env.Append(LINKFLAGS = os.environ['LDFLAGS'])
		print(">> Appending custom link flags : " + os.environ['LDFLAGS'])

	if 'LIBS' in os.environ:
		autoconf.env.Append(APPEND_LIBS = os.environ['LIBS'])
		print(">> Appending custom libraries : " + os.environ['LIBS'])
	else:
		autoconf.env.Append(APPEND_LIBS = '')

	autoconf.env.Append(
		LIBBROTLI = '',
		LIBBZ2 = '',
		LIBCRYPT = '',
		LIBCRYPTO = '',
		LIBDBI = '',
		LIBDL = '',
		LIBFCGI = '',
		LIBGDBM = '',
		LIBGNUTLS = '',
		LIBGSSAPI_KRB5 = '',
		LIBKRB5 = '',
		LIBLBER = '',
		LIBLDAP = '',
		LIBLUA = '',
		LIBMEMCACHED = '',
		LIBMYSQL = '',
		LIBNSS = '',
		LIBPAM = '',
		LIBPCRE = '',
		LIBPGSQL = '',
		LIBSASL = '',
		LIBSQLITE3 = '',
		LIBSSL = '',
		LIBUUID = '',
		LIBX509 = '',
		LIBXML2 = '',
		LIBXXHASH = '',
		LIBZ = '',
	)

	autoconf.haveCHeaders([
		'arpa/inet.h',
		'crypt.h',
		'fcntl.h',
		'getopt.h',
		'inttypes.h',
		'linux/random.h',
		'poll.h',
		'pwd.h',
		'stdint.h',
		'stdlib.h',
		'string.h',
		'strings.h',
		'sys/devpoll.h',
		'sys/epoll.h',
		'sys/filio.h',
		'sys/loadavg.h',
		'sys/poll.h',
		'sys/port.h',
		'sys/prctl.h',
		'sys/sendfile.h',
		'sys/time.h',
		'sys/wait.h',
		'syslog.h',
		'unistd.h',
		'winsock2.h',

		# "have" the last header if we include others before?
		['sys/types.h', 'sys/time.h', 'sys/resource.h'],
		['sys/types.h', 'netinet/in.h'],
		['sys/types.h', 'sys/event.h'],
		['sys/types.h', 'sys/mman.h'],
		['sys/types.h', 'sys/select.h'],
		['sys/types.h', 'sys/socket.h'],
		['sys/types.h', 'sys/uio.h'],
		['sys/types.h', 'sys/un.h'],
	])

	autoconf.haveFuncs([
		'arc4random_buf',
		'chroot',
		'clock_gettime',
		'copy_file_range',
		'dup2',
		'epoll_ctl',
		'explicit_bzero',
		'explicit_memset',
		'fork',
		'getcwd',
		'gethostbyname',
		'getloadavg',
		'getopt',
		'getrlimit',
		'getuid',
		'inet_ntoa',
		'inet_ntop',
		'inet_pton',
		'issetugid',
		'jrand48',
		'kqueue',
		'localtime_r',
		'lstat',
		'madvise',
		'memset_s',
		'memset',
		'mmap',
		'munmap',
		'pathconf',
		'pipe2',
		'poll',
		'port_create',
		'posix_fadvise',
		'prctl',
		'select',
		'send_file',
		'sendfile',
		'sendfile64',
		'sigaction',
		'signal',
		'socket',
		'srandom',
		'stat',
		'strchr',
		'strdup',
		'strerror',
		'strftime',
		'strstr',
		'strtol',
		'writev',
	])
	autoconf.haveFunc('getentropy', 'sys/random.h')
	autoconf.haveFunc('getrandom', 'linux/random.h')

	autoconf.haveTypes(Split('pid_t size_t off_t'))

	# have crypt_r/crypt, and is -lcrypt needed?
	if autoconf.CheckLib('crypt'):
		autoconf.env.Append(
			CPPFLAGS = [ '-DHAVE_LIBCRYPT' ],
			LIBCRYPT = 'crypt',
		)
		with autoconf.restoreEnvLibs():
			autoconf.env['LIBS'] = ['crypt']
			autoconf.haveFuncs(['crypt', 'crypt_r'])
	else:
		autoconf.haveFuncs(['crypt', 'crypt_r'])

	if autoconf.CheckType('socklen_t', '#include <unistd.h>\n#include <sys/socket.h>\n#include <sys/types.h>'):

=== src/CMakeLists.txt ===
include(CheckCSourceCompiles)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckVariableExists)
include(CheckTypeSize)
include(CheckLibraryExists)
include(CMakeDetermineCCompiler)
include(FindThreads)
include(FindPkgConfig)

include(LighttpdMacros)

add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGE_FILES)

# default to ON
set(CMAKE_POSITION_INDEPENDENT_CODE ON CACHE BOOL "Default value for ``POSITION_INDEPENDENT_CODE`` of targets.")

option(WITH_XATTR "with xattr-support for the stat-cache [default: off]")
option(WITH_MYSQL "with mysql-support for mod_vhostdb_mysql [default: off]")
option(WITH_PGSQL "with postgres-support for mod_vhostdb_pgsql [default: off]")
option(WITH_DBI "with dbi-support for mod_vhostdb_dbi [default: off]")
option(WITH_GNUTLS "with GnuTLS-support [default: off]")
option(WITH_MBEDTLS "with mbedTLS-support [default: off]")
option(WITH_NSS "with NSS-crypto-support [default: off]")
option(WITH_OPENSSL "with openssl-support [default: off]")
option(WITH_WOLFSSL "with wolfSSL-support [default: off]")
option(WITH_NETTLE "with Nettle-support [default: off]")
option(WITH_PCRE "with regex support [default: on]" ON)
option(WITH_WEBDAV_PROPS "with property-support for mod_webdav [default: off]")
option(WITH_WEBDAV_LOCKS "locks in webdav [default: off]")
option(WITH_BROTLI "with brotli-support for mod_deflate [default: off]")
option(WITH_BZIP "with bzip2-support for mod_deflate [default: off]")
option(WITH_ZLIB "with deflate-support for mod_deflate [default: on]" ON)
option(WITH_KRB5 "with Kerberos5-support for mod_auth [default: off]")
option(WITH_LDAP "with LDAP-support for mod_auth mod_vhostdb_ldap [default: off]")
option(WITH_PAM "with PAM-support for mod_auth [default: off]")
option(WITH_LUA "with lua 5.1 for mod_magnet [default: off]")
# option(WITH_VALGRIND "with internal support for valgrind [default: off]")
option(WITH_FAM "fam/gamin for reducing number of stat() calls [default: off]")
option(WITH_GDBM "gdbm storage for mod_trigger_b4_dl [default: off]")
option(WITH_MEMCACHED "memcached storage for mod_trigger_b4_dl [default: off]")
option(WITH_LIBEV "libev support for fdevent handlers [default: off]")
option(WITH_LIBUNWIND "with libunwind to print backtraces in asserts [default: off]")
option(WITH_GEOIP "with GeoIP-support mod_geoip [default: off]")
option(WITH_MAXMINDDB "with MaxMind GeoIP2-support mod_maxminddb [default: off]")
option(WITH_SASL "with SASL-support for mod_authn_sasl [default: off]")
option(WITH_XXHASH "with system-provided xxhash [default: off]")

if(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	option(BUILD_EXTRA_WARNINGS "extra warnings")

	if(BUILD_EXTRA_WARNINGS)
		set(WARN_CFLAGS "-g -g2 -Wall -Wmissing-declarations -Wcast-align -Wsign-compare -Wnested-externs -Wpointer-arith -D_FORTIFY_SOURCE=2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Werror=format-security")
		set(WARN_LDFLAGS "-Wl,--as-needed")
		# -Werror -Wbad-function-cast -Wmissing-prototypes
	endif()
endif()

option(BUILD_STATIC "build a static lighttpd with all modules added")

if(BUILD_STATIC)
	set(LIGHTTPD_STATIC 1)
elseif(APPLE)
	set(CMAKE_SHARED_MODULE_PREFIX "")
else()
	set(CMAKE_SHARED_LIBRARY_PREFIX "")
endif()

if(WITH_LIBEV)
	find_package(LibEV REQUIRED)
	set(HAVE_LIBEV 1)
endif()

if(WITH_LIBUNWIND)
	pkg_check_modules(LIBUNWIND REQUIRED libunwind)
	set(HAVE_LIBUNWIND 1)
endif()

if(WITH_WEBDAV_PROPS)
	set(WITH_XML 1)
	set(WITH_SQLITE3 1)
endif()

if(WITH_WEBDAV_LOCKS)
	set(WITH_UUID 1)
endif()

check_include_files(sys/devpoll.h HAVE_SYS_DEVPOLL_H)
check_include_files(sys/epoll.h HAVE_SYS_EPOLL_H)
set(CMAKE_REQUIRED_FLAGS "-include sys/types.h")
check_include_files(sys/event.h HAVE_SYS_EVENT_H)
set(CMAKE_REQUIRED_FLAGS)
check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
check_include_files(sys/loadavg.h HAVE_SYS_LOADAVG_H)
check_include_files(sys/poll.h HAVE_SYS_POLL_H)
check_include_files(sys/port.h HAVE_SYS_PORT_H)
check_include_files(sys/prctl.h HAVE_SYS_PRCTL_H)
check_include_files(sys/resource.h HAVE_SYS_RESOURCE_H)
check_include_files(sys/sendfile.h HAVE_SYS_SENDFILE_H)
check_include_files(sys/select.h HAVE_SYS_SELECT_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(sys/uio.h HAVE_SYS_UIO_H)
check_include_files(sys/un.h HAVE_SYS_UN_H)
check_include_files(sys/wait.h HAVE_SYS_WAIT_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(pthread.h HAVE_PTHREAD_H)
check_include_files(getopt.h HAVE_GETOPT_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(poll.h HAVE_POLL_H)
check_include_files(pwd.h HAVE_PWD_H)
check_include_files(stddef.h HAVE_STDDEF_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(syslog.h HAVE_SYSLOG_H)

# check for fastcgi lib, for the tests only
check_include_files(fastcgi.h HAVE_FASTCGI_H)
check_include_files(fastcgi/fastcgi.h HAVE_FASTCGI_FASTCGI_H)

# will be needed for auth
check_include_files(crypt.h HAVE_CRYPT_H)
# check if we need libcrypt for crypt_r()
check_library_exists(crypt crypt_r "" HAVE_LIBCRYPT_CRYPT_R)
if(HAVE_LIBCRYPT_CRYPT_R)
	set(HAVE_CRYPT_R 1)
	set(HAVE_LIBCRYPT 1)
else()
	check_library_exists(crypt crypt "" HAVE_LIBCRYPT)
endif()
check_function_exists(crypt_r HAVE_CRYPT_R)
check_function_exists(crypt HAVE_CRYPT)

check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
if(HAVE_SYS_INOTIFY_H)
	check_function_exists(inotify_init HAVE_INOTIFY_INIT)
endif()

set(CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
check_type_size(socklen_t HAVE_SOCKLEN_T)
set(CMAKE_EXTRA_INCLUDE_FILES)

check_include_files(sys/random.h HAVE_SYS_RANDOM_H)
set(CMAKE_EXTRA_INCLUDE_FILES sys/random.h)
check_function_exists(getentropy HAVE_GETENTROPY)
set(CMAKE_EXTRA_INCLUDE_FILES)

check_include_files(linux/random.h HAVE_LINUX_RANDOM_H)
set(CMAKE_EXTRA_INCLUDE_FILES linux/random.h)
check_function_exists(getrandom HAVE_GETRANDOM)
set(CMAKE_EXTRA_INCLUDE_FILES)

check_type_size(long SIZEOF_LONG)
check_type_size(off_t SIZEOF_OFF_T)

check_function_exists(arc4random_buf HAVE_ARC4RANDOM_BUF)
check_function_exists(chroot HAVE_CHROOT)
check_function_exists(copy_file_range HAVE_COPY_FILE_RANGE)
check_function_exists(epoll_ctl HAVE_EPOLL_CTL)
check_function_exists(fork HAVE_FORK)
check_function_exists(getloadavg HAVE_GETLOADAVG)
check_function_exists(getrlimit HAVE_GETRLIMIT)
check_function_exists(getuid HAVE_GETUID)
check_function_exists(gmtime_r HAVE_GMTIME_R)
check_function_exists(inet_ntop HAVE_INET_NTOP)
check_function_exists(jrand48 HAVE_JRAND48)
check_function_exists(kqueue HAVE_KQUEUE)
check_function_exists(localtime_r HAVE_LOCALTIME_R)
check_function_exists(lstat HAVE_LSTAT)
check_function_exists(madvise HAVE_MADVISE)
check_function_exists(memcpy HAVE_MEMCPY)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(mmap HAVE_MMAP)
check_function_exists(pathconf HAVE_PATHCONF)
check_function_exists(pipe2 HAVE_PIPE2)
check_function_exists(poll HAVE_POLL)
check_function_exists(port_create HAVE_PORT_CREATE)
check_function_exists(prctl HAVE_PRCTL)
check_function_exists(pread HAVE_PREAD)
check_function_exists(posix_fadvise HAVE_POSIX_FADVISE)
check_function_exists(select HAVE_SELECT)
check_function_exists(sendfile HAVE_SENDFILE)
check_function_exists(send_file HAVE_SEND_FILE)
check_function_exists(sendfile64 HAVE_SENDFILE64)
check_function_exists(sendfilev HAVE_SENDFILEV)
check_function_exists(sigaction HAVE_SIGACTION)
check_function_exists(signal HAVE_SIGNAL)
check_function_exists(sigtimedwait HAVE_SIGTIMEDWAIT)
check_function_exists(srandom HAVE_SRANDOM)
check_function_exists(strptime HAVE_STRPTIME)
check_function_exists(syslog HAVE_SYSLOG)
check_function_exists(writev HAVE_WRITEV)
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(issetugid HAVE_ISSETUGID)
check_function_exists(inet_pton HAVE_INET_PTON)
check_function_exists(memset_s HAVE_MEMSET_S)
check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
check_function_exists(explicit_memset HAVE_EXPLICIT_MEMSET)
check_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
if (NOT HAVE_CLOCK_GETTIME)
	check_library_exists(rt clock_gettime "time.h" HAVE_CLOCK_GETTIME)
endif()
check_library_exists(elftc elftc_copyfile "libelftc.h" HAVE_ELFTC_COPYFILE)
check_c_source_compiles("
	#include <sys/types.h>
	#include <sys/socket.h>
	#include <netinet/in.h>

	int main() {
		struct sockaddr_in6 s; struct in6_addr t=in6addr_any; int i=AF_INET6; s; t.s6_addr[0] = 0;
		return 0;
	}" HAVE_IPV6)
check_c_source_compiles("
	__attribute__((weak)) void __dummy(void *x) { }
	int main() {
		void *x;
		__dummy(x);
	}
	" HAVE_WEAK_SYMBOLS)
check_c_source_compiles("
	#include <time.h>
	int main(void) {
		struct tm t;
		t.tm_gmtoff = 0;
		return 0;
	}
	" HAVE_STRUCT_TM_GMTOFF)

## refactor me
macro(XCONFIG _package _include_DIR _link_DIR _link_FLAGS _cflags)
# reset the variables at the beginning
	set(${_include_DIR})
	set(${_link_DIR})
	set(${_link_FLAGS})
	set(${_cflags})

	find_program(${_package}CONFIG_EXECUTABLE NAMES ${_package} PATHS /usr/local/bin )

	# if pkg-config has been found
	if(${_package}CONFIG_EXECUTABLE)
		set(XCONFIG_EXECUTABLE "${${_package}CONFIG_EXECUTABLE}")
		message(STATUS "found ${_package}: ${XCONFIG_EXECUTABLE}")

		exec_program(${XCONFIG_EXECUTABLE} ARGS --libs OUTPUT_VARIABLE __link_FLAGS)
		string(REPLACE "\n" "" ${_link_FLAGS} ${__link_FLAGS})
		exec_program(${XCONFIG_EXECUTABLE} ARGS --cflags OUTPUT_VARIABLE __cflags)
		string(REPLACE "\n" "" ${_cflags} ${__cflags})
	else()
		message(STATUS "found ${_package}: no")
	endif()
endmacro(XCONFIG _package _include_DIR _link_DIR _link_FLAGS _cflags)

if(WITH_XATTR)
	check_include_files("sys/types.h;sys/xattr.h" HAVE_SYS_XATTR_H)
	check_function_exists(getxattr HAVE_XATTR)
	check_include_files("sys/types.h;attr/attributes.h" HAVE_ATTR_ATTRIBUTES_H)
	if(HAVE_ATTR_ATTRIBUTES_H)
		check_library_exists(attr attr_get "" HAVE_XATTR)
	endif()
else()
	unset(HAVE_ATTR_ATTRIBUTES_H)
	unset(HAVE_XATTR)
endif()

if(WITH_MYSQL)
	xconfig(mysql_config MYSQL_INCDIR MYSQL_LIBDIR MYSQL_LDFLAGS MYSQL_CFLAGS)

	set(CMAKE_REQUIRED_INCLUDES /usr/include/mysql)
	check_include_files(mysql.h HAVE_MYSQL_H)
	set(CMAKE_REQUIRED_INCLUDES)
	if(HAVE_MYSQL_H)
		check_library_exists(mysqlclient mysql_real_connect "" HAVE_MYSQL)
	endif()
else()
	unset(HAVE_MYSQL_H)
	unset(HAVE_MYSQL)
endif()

if(WITH_PGSQL)
	xconfig(pg_config PGSQL_INCDIR PGSQL_LIBDIR PGSQL_LDFLAGS PGSQL_CFLAGS)

	check_include_files(libpq-fe.h HAVE_PGSQL_H)
	if(HAVE_PGSQL_H)
		check_library_exists(pq PQsetdbLogin "" HAVE_PGSQL)
	endif()
else()
	unset(HAVE_PGSQL_H)
	unset(HAVE_PGSQL)
endif()

if(WITH_DBI)
	check_include_files(dbi/dbi.h HAVE_DBI_H)
	if(HAVE_DBI_H)
		check_library_exists(dbi dbi_conn_connect "" HAVE_DBI)
	endif()
else()
	unset(HAVE_DBI_H)
	unset(HAVE_DBI)
endif()

set(CRYPTO_LIBRARY "")

if(WITH_OPENSSL)
	if(APPLE)
		set(CMAKE_REQUIRED_INCLUDES /opt/local/include)
	endif()
	check_include_files(openssl/ssl.h HAVE_OPENSSL_SSL_H)
	if(APPLE)
		set(CMAKE_REQUIRED_INCLUDES)
	endif()
	if(HAVE_OPENSSL_SSL_H)
		check_library_exists(crypto BIO_f_base64 "" HAVE_LIBCRYPTO)
		if(HAVE_LIBCRYPTO)
			set(CRYPTO_LIBRARY crypto)
			check_library_exists(ssl SSL_new "" HAVE_LIBSSL)
			set(HAVE_OPENSSL 1)
		endif()
	endif()
else()
	unset(HAVE_OPENSSL_SSL_H)
	unset(HAVE_LIBSSL)
endif()

if(WITH_WOLFSSL)
	pkg_check_modules(WOLFSSL QUIET wolfssl)
	if(NOT ${WITH_WOLFSSL} EQUAL "")
		find_path(WOLFSSL_INCLUDE_DIR wolfssl/ssl.h ${WITH_WOLFSSL}/include)
	elseif(WOLFSSL_FOUND)
		set(WOLFSSL_INCLUDE_DIR ${WOLFSSL_INCLUDE_DIRS})
	elseif(APPLE)
		find_path(WOLFSSL_INCLUDE_DIR wolfssl/ssl.h /opt/local/include)
	else()
		find_path(WOLFSSL_INCLUDE_DIR wolfssl/ssl.h /usr/local/include)
	endif()

	if(NOT ${WITH_WOLFSSL} EQUAL "")
		find_library(WOLFSSL_LIBRARY
			NAMES wolfssl
			PATHS ${WITH_WOLFSSL}/lib
		)
	elseif(WOLFSSL_FOUND)

=== debian/changelog ===
lighttpd (1.4.56~rc7-1) unstable; urgency=medium

  * Upload to unstable.
  * drop mod_authn_dbi.so from debian/not-installed

 -- Helmut Grohne <helmut.grohne@intenta.de>  Sat, 07 Nov 2020 11:03:57 +0100

lighttpd (1.4.56~rc7-0+exp2) experimental; urgency=medium

  [ Glenn Strauss ]
  * build lighttpd base against Nettle
  * split off package lighttpd-mod-openssl
  * split off package lighttpd-mod-deflate
  * merge lighttpd-mod-cml and lighttpd-mod-magnet into lighttpd-modules-lua
  * replace mod_compress with mod_deflate
  * build with brotli support; replace bzip2 support
  * separate package for each TLS module
    mod_openssl, mod_mbedtls, mod_nss, mod_wolfssl
  * new package lighttpd-modules-dbi with mod_authn_dbi, mod_vhostdb_dbi
  * document deprecated modules: mod_authn_mysql, mod_mysql_vhost
  * remove libattr1-dev dependency

  [ Helmut Grohne ]
  * remove mod_deflate from the default configuration

  [ Glenn Strauss ]
  * lighttpd.conf enable HTTP/2 feature

  [ Helmut Grohne ]
  * use the system libxxhash instead of our vendor copy

 -- Helmut Grohne <helmut.grohne@intenta.de>  Thu, 05 Nov 2020 20:18:08 +0100

lighttpd (1.4.56~rc7-0+exp1) experimental; urgency=medium

  * New upstream version 1.4.56~rc7

 -- Helmut Grohne <helmut.grohne@intenta.de>  Tue, 03 Nov 2020 05:51:40 +0100

lighttpd (1.4.56~rc2-0+exp1) experimental; urgency=medium

  * fix php-fpm socket path.
    Thanks to Joe Nahmias <joe@nahmias.net> (Closes: #973300)
  * New upstream version 1.4.56~rc2
    + Update debian/copyright
    + Drop all patches - all applied upstream
    + mod_compress is merged into mod_deflate
    + Skip installing mod_authn_dbi for now
    + load-all-modules test skips deprecated mod_vhost_mysql

 -- Helmut Grohne <helmut.grohne@intenta.de>  Mon, 02 Nov 2020 19:54:18 +0100

lighttpd (1.4.55-2) unstable; urgency=medium

  [ Glenn Strauss ]
  * remove upstream source files from debian/clean
  * use lua 5.3 going forwards (update from lua 5.1)
  * 05-auth.conf comment available algorithm SHA-256
  * 10-ssl.conf listens on IPv4, and IPv6 when avail (Closes: #952541)
  * patch: mod_openssl inherit cfg from global scope (Closes: #952541)
  * /var/run -> /run
  * lighty-enable-mod fastcgi-php-fpm option (Closes: #916677)
  * patch: dlsym for FAMNoExists (!18) (!22)
  * document mod_geoip deprecated

  [ Debian Janitor ]
  * Wrap long lines in changelog entries: 1.4.16-1, 1.4.15-1, 1.4.13-10,
    1.4.10-2.

  [ bauen1 ]
  * remove usage of 'su' in crontab (Closes: #958520)

 -- Helmut Grohne <helmut.grohne@intenta.de>  Mon, 26 Oct 2020 17:45:11 +0100

=== debian/control ===
Source: lighttpd
Section: httpd
Priority: optional
Maintainer: Debian lighttpd maintainers <team+lighttpd@tracker.debian.org>
Uploaders: Helmut Grohne <helmut.grohne@intenta.de>, Glenn Strauss <gstrauss@gluelogic.com>, Stefan Bühler <stbuehler@web.de>
Homepage: https://www.lighttpd.net/
Build-Depends:
 dpkg-dev (>= 1.16.1~),
 debhelper (>= 10~),
 mime-support,
 libmbedtls-dev,
 libnss3-dev,
 libssl-dev,
 libwolfssl-dev,
 zlib1g-dev,
 libbrotli-dev,
 libpcre3-dev,
 default-libmysqlclient-dev | libmysqlclient-dev,
 libdbi-dev,
 libfam-dev,
 libldap2-dev,
 libfcgi-dev,
 libgdbm-dev,
 libgeoip-dev,
 liblua5.3-dev,
 libmaxminddb-dev,
 libmemcached-dev,
 pkg-config,
 uuid-dev,
 libsqlite3-dev,
 libxml2-dev,
 libkrb5-dev,
 libpam0g-dev,
 libpq-dev,
 libsasl2-dev,
 libunwind8-dev <pkg.lighttpd.libunwind>,
 libxxhash-dev,
 nettle-dev,
 perl:native,
 php-cgi:native <!nocheck> | php5-cgi:native <!nocheck>,
Vcs-Git: https://salsa.debian.org/debian/lighttpd.git
Vcs-Browser: https://salsa.debian.org/debian/lighttpd
Standards-Version: 4.5.0
Rules-Requires-Root: binary-targets

Package: lighttpd
Architecture: any
Provides:
 httpd,
 httpd-cgi,
 ${lighttpd:ModuleProvides},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 mime-support,
 lsb-base (>= 3.0-6),
Recommends:
 spawn-fcgi,
 perl:any,
 lighttpd-mod-deflate,
 lighttpd-mod-openssl,
Suggests:
 openssl,
 rrdtool,
 php-cgi,
 php-fpm (>= 7.4),
 apache2-utils,
 lighttpd-doc,
 lighttpd-mod-authn-gssapi,
 lighttpd-mod-authn-pam,
 lighttpd-mod-authn-sasl,
 lighttpd-mod-geoip,
 lighttpd-mod-maxminddb,
 lighttpd-mod-trigger-b4-dl,
 lighttpd-mod-vhostdb-pgsql,
 lighttpd-mod-webdav,
 lighttpd-modules-dbi,
 lighttpd-modules-ldap,
 lighttpd-modules-lua,
 lighttpd-modules-mysql,
Description: fast webserver with minimal memory footprint
 lighttpd is a small webserver and fast webserver developed with
 security in mind and a lot of features.
 It has support for
   * CGI, FastCGI and SSI
   * virtual hosts
   * URL rewriting
   * authentication (plain files, htpasswd, LDAP)
   * transparent content compression
   * conditional configuration
   * HTTP proxying
 and configuration is straight-forward and easy.

Package: lighttpd-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 lighttpd,
Description: documentation for lighttpd
 lighttpd is a small webserver and fast webserver developed with
 security in mind and a lot of features.
 .
 This package contains documentation for lighttpd.

Package: lighttpd-modules-dbi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks:
 lighttpd-mod-vhostdb-dbi (<< 1.4.56~rc7-0+exp2),
Replaces:
 lighttpd (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-vhostdb-dbi (<< 1.4.56~rc7-0+exp2),
Provides:
 ${lighttpd:ModuleProvides},
Description: DBI-based modules for lighttpd
 This package contains the following modules:
  * mod_authn_dbi: DBI-based authentication
    mod_authn_dbi performs authentication against a database server
    via DBI interface.
  * mod_vhostdb_dbi: DBI-based virtual host configuration
    mod_vhostdb_dbi enables writing the configuration for virtual hosts
    into a database table instead of including it in the lighttpd
    configuration file.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-ldap
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks:
 lighttpd (<< 1.4.52-2+exp1),
 lighttpd-mod-authn-ldap (<< 1.4.52-2+exp1),
Replaces:
 lighttpd (<< 1.4.52-2+exp1),
 lighttpd-mod-authn-ldap (<< 1.4.52-2+exp1),
Provides:
 ${lighttpd:ModuleProvides},
Description: LDAP-based modules for lighttpd
 This package contains the following modules:
  * mod_authn_ldap: With this module, it is possible to perform
    authentication against an LDAP server.
  * mod_vhostdb_ldap: Database backend module for using LDAP as
    a source for virtual host configuration using mod_vhostdb.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-lua
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks:
 lighttpd-mod-cml (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-magnet (<< 1.4.56~rc7-0+exp2),
Replaces:
 lighttpd (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-cml (<< 1.4.56~rc7-0+exp2),
 lighttpd-mod-magnet (<< 1.4.56~rc7-0+exp2),
Provides:
 ${lighttpd:ModuleProvides},
Description: LUA-based modules for lighttpd
 This package contains the following modules:
  * mod_magnet: control the request handling module for lighttpd
    mod_magnet can attract a request in several stages in the request-handling.
    either at the same level as mod_rewrite, before any parsing of the URL is
    done or at a later stage, when the doc-root is known and the physical-path
    is already setup.
  * mod_cml: cache meta language module for lighttpd
    With the cache meta language, it is possible to describe to the
    dependencies of a cached file to its source files/scripts. For the
    cache files, the scripting language Lua is used.
    THIS MODULE IS OBSOLETED, USE mod_magnet INSTEAD.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-modules-mysql
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks:
 lighttpd (<< 1.4.52-2+exp1),
 lighttpd-mod-mysql-vhost (<< 1.4.52-2+exp1),
 lighttpd-mod-authn-mysql (<< 1.4.52-2+exp1),
Replaces:
 lighttpd (<< 1.4.52-2+exp1),
 lighttpd-mod-mysql-vhost (<< 1.4.52-2+exp1),
 lighttpd-mod-authn-mysql (<< 1.4.52-2+exp1),
Provides:
 ${lighttpd:ModuleProvides},
Description: MySQL-based modules for lighttpd
 This package contains the following modules:
  * mod_authn_mysql: With this module, it is possible to perform
    authentication using a MySQL table.
    This module is deprecated and will be removed in Debian 12 Bookworm.
    Use mod_authn_dbi instead.
  * mod_mysql_vhost: With this module, it is possible to write the
    configuration for virtual hosts into a MySQL table instead of
    including it in the lighttpd configuration file.
    This module is deprecated and will be removed in Debian 12 Bookworm.
    Use mod_vhostdb_dbi or mod_vhostdb_mysql instead.
  * mod_vhostdb_mysql: Database backend module for using MySQL as
    a source for virtual host configuration using mod_vhostdb.
 .
 Do not depend on this package. Depend on the provided lighttpd-mod-*
 packages instead.

Package: lighttpd-mod-trigger-b4-dl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Recommends:
 memcached,
Description: anti-deep-linking module for lighttpd
 The trigger-b4-dl module for lighttpd can prevent deep linking
 from other sites by requiring users to visit a trigger URL to
 be able to download certain files.

Package: lighttpd-mod-cml
Section: oldlibs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd-modules-lua (= ${binary:Version}),
Description: Transitional dummy package for: cache meta language module for lighttpd
 With the cache meta language, it is possible to describe to the
 dependencies of a cached file to its source files/scripts. For the
 cache files, the scripting language Lua is used.
 .
 THIS MODULE IS OBSOLETED, USE mod_magnet INSTEAD.
 .
 While this transitional dummy package will go away, the package name
 continues to exist as a virtual package provided by lighttpd-modules-lua.

Package: lighttpd-mod-magnet
Section: oldlibs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd-modules-lua (= ${binary:Version}),
Description: Transitional dummy package for: control the request handling module for lighttpd
 mod_magnet can attract a request in several stages in the request-handling.
 either at the same level as mod_rewrite, before any parsing of the URL is done
 or at a later stage, when the doc-root is known and the physical-path is
 already setup
 .
 While this transitional dummy package will go away, the package name
 continues to exist as a virtual package provided by lighttpd-modules-lua.

Package: lighttpd-mod-webdav
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: WebDAV module for lighttpd
 The WebDAV module is an implementation of RFC 4918.
 .
 Currently supports:
  GET
  POST
  HEAD
  PROPFIND
  PROPPATCH
  OPTIONS
  MKCOL
  COPY
  MOVE
  DELETE
  PUT
  LOCK
  UNLOCK

Package: lighttpd-mod-authn-gssapi
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: GSSAPI authentication module for lighttpd
 This package contains the authn_gssapi module for lighttpd. With
 this module, it is possible to perform GSSAPI authentication.

Package: lighttpd-mod-authn-pam
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: PAM authentication module for lighttpd
 This package contains the authn_pam module for lighttpd. With this module, it
 is possible to perform authentication using PAM.

Package: lighttpd-mod-authn-sasl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: SASL authentication module for lighttpd
 This package contains the authn_sasl module for lighttpd. With this module, it
 is possible to perform authentication using SASL.

Package: lighttpd-mod-deflate
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Breaks: lighttpd (<< 1.4.56~rc7-0+exp2)
Replaces: lighttpd (<< 1.4.56~rc7-0+exp2)
Description: HTTP response compression module for lighttpd
 This package contains the deflate module for lighttpd. With this module, it is
 possible compress HTTP responses using zlib, brotli, or bzip2 if supported by
 the client.

Package: lighttpd-mod-geoip
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: GeoIP info module for lighttpd
 This package contains the geoip module for lighttpd. With
 this module, it is possible to distinguish users based on the location
 using a GeoIP database.
 .
 This module is deprecated and will be removed in Debian 12 Bookworm.
 Legacy GeoIP databases will not be available from upstream after May 2022.
 Instead, use mod_maxminddb, which uses GeoIP2 databases.

Package: lighttpd-mod-maxminddb
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: GeoIP2 info module for lighttpd
 This package contains the maxminddb module for lighttpd. With
 this module, it is possible to distinguish users based on the location
 using a GeoIP2 database.

Package: lighttpd-mod-vhostdb-dbi
Section: oldlibs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd-modules-dbi (= ${binary:Version}),
Description: Transitional dummy package for: DBI-based virtual host configuration module for lighttpd
 This package contains the vhostdb_dbi module for lighttpd. With this module,
 it is possible to write the configuration for virtual hosts into a database
 table instead of including it in the lighttpd configuration file.
 .
 While this transitional dummy package will go away, the package name
 continues to exist as a virtual package provided by lighttpd-modules-dbi.

Package: lighttpd-mod-vhostdb-pgsql
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 lighttpd (= ${binary:Version}),
Description: PostgreSQL-based virtual host configuration module for lighttpd
 This package contains the vhostdb_pgsql module for lighttpd. With this module,
 it is possible to write the configuration for virtual hosts into a PostgreSQL
 table instead of including it in the lighttpd configuration file.

Package: lighttpd-mod-mbedtls
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},

=== debian/rules ===
#!/usr/bin/make -f

# enable verbose mode
export DH_VERBOSE=1

# enable all hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_clean:
	dh_clean
	find . -name Makefile.in -delete

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-dependency-tracking \
		--libdir=/usr/lib/lighttpd \
		--libexecdir="/usr/lib/lighttpd" \
		--with-attr \
		--with-brotli \
		--with-dbi \
		--with-fam \
		--with-gdbm \
		--with-krb5 \
		--with-ldap \
		--with-geoip \
		--with-memcached \
		--with-lua=lua5.3 \
		--with-maxminddb \
		--with-mbedtls \
		--with-mysql \
		--with-nettle \
		--with-nss \
		--with-openssl \
		--with-pam \
		--with-pcre \
		--with-pgsql \
		--with-sasl \
		--with-webdav-locks \
		--with-webdav-props \
		--with-wolfssl \
		--with-xxhash \
		$(if $(filter pkg.lighttpd.libunwind,$(DEB_BUILD_PROFILES)),--with-libunwind) \
		CFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get CFLAGS)" \
		LDFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get LDFLAGS)" \
		CPPFLAGS_FOR_BUILD="$(shell dpkg-buildflags --get CPPFLAGS)" \

override_dh_install:
	cp NEWS debian/tmp/changelog
	dh_install

override_dh_missing:
	dh_missing --fail-missing

DOCLESS_PACKAGES=\
	lighttpd-modules-dbi \
	lighttpd-modules-ldap \
	lighttpd-modules-mysql \
	lighttpd-mod-authn-pam \
	lighttpd-mod-authn-sasl \
	lighttpd-mod-deflate \
	lighttpd-mod-maxminddb \
	lighttpd-mod-vhostdb-dbi \
	lighttpd-mod-vhostdb-pgsql \

override_dh_installdocs:
	dh_installdocs $(foreach p,$(DOCLESS_PACKAGES),-p$(p)) --link-doc=lighttpd
	dh_installdocs $(foreach p,$(DOCLESS_PACKAGES),-N$(p))

override_dh_fixperms-arch:
	dh_fixperms
	chmod 0750 debian/lighttpd/var/log/lighttpd
	chown www-data:www-data \
			debian/lighttpd/var/cache/lighttpd \
			debian/lighttpd/var/cache/lighttpd/compress \
			debian/lighttpd/var/cache/lighttpd/uploads \
			debian/lighttpd/var/log/lighttpd

override_dh_installinit:
	dh_installinit --error-handler=start_failed

override_dh_gencontrol:
	set -e; for p in `dh_listpackages`; do \
		test -d debian/$$p/usr/lib/lighttpd || continue; \
		m=`ls debian/$$p/usr/lib/lighttpd | sed 'y/_/-/;s/^mod-\(.*\)\.so$$/lighttpd-mod-\1,/;ta;d;:a /^'"$$p"',$$/d;' | xargs`; \
		echo "lighttpd:ModuleProvides=$$m" >> debian/$$p.substvars; \
	done
	dh_gencontrol

=== debian/tests/control ===
Tests: defconfig
Depends: lighttpd
Restrictions: needs-root

Tests: load-all-modules
Depends: lighttpd, lighttpd-modules-ldap, lighttpd-modules-lua, lighttpd-modules-mysql, lighttpd-mod-trigger-b4-dl, lighttpd-mod-webdav, lighttpd-mod-authn-gssapi, lighttpd-mod-authn-pam, lighttpd-mod-authn-sasl, lighttpd-mod-deflate, lighttpd-mod-geoip, lighttpd-mod-maxminddb, lighttpd-mod-vhostdb-dbi, lighttpd-mod-vhostdb-pgsql

Tests: serve-static-file
Depends: lighttpd, curl
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
https://download.lighttpd.net/lighttpd/releases-1.4.x/ lighttpd-(.*)\.tar\.xz

## lighttpd 1.4.56

=== SConstruct ===
--- 
+++ 
@@ -371,6 +371,7 @@
 		'sys/devpoll.h',
 		'sys/epoll.h',
 		'sys/filio.h',
+		'sys/inotify.h',
 		'sys/loadavg.h',
 		'sys/poll.h',
 		'sys/port.h',
@@ -462,4 +463,3 @@
 	else:
 		autoconf.haveFuncs(['crypt', 'crypt_r'])
 
-	if autoconf.CheckType('socklen_t', '#include <unistd.h>\n#include <sys/socket.h>\n#include <sys/types.h>'):

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -91,6 +91,7 @@
 set(CMAKE_REQUIRED_FLAGS "-include sys/types.h")
 check_include_files(sys/event.h HAVE_SYS_EVENT_H)
 set(CMAKE_REQUIRED_FLAGS)
+check_include_files(sys/inotify.h HAVE_SYS_INOTIFY_H)
 check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
 check_include_files(sys/loadavg.h HAVE_SYS_LOADAVG_H)
 check_include_files(sys/poll.h HAVE_SYS_POLL_H)
@@ -337,6 +338,3 @@
 	if(NOT ${WITH_WOLFSSL} EQUAL "")
 		find_library(WOLFSSL_LIBRARY
 			NAMES wolfssl
-			PATHS ${WITH_WOLFSSL}/lib
-		)
-	elseif(WOLFSSL_FOUND)

=== debian/changelog ===
lighttpd (1.4.56-1) unstable; urgency=medium

  [ Justin Aplin ]
  * build: Set Build-Depends of libwolfssl-dev to >=4.2.0 due to missing TLS
    version macros in previous versions

  [ Glenn Strauss ]
  * tests/serve-cgi-file,do-not-emit-http-proxy-to-cgi.
    Thanks to Santiago Ruano Rincón <santiagorr@riseup.net> (Closes: #834625)
  * remove lighttpd dependency on FAM or gamin
  * remove --with-fam from build rules
  * patch for lighttpd -1 with pipes
  * patches for mod_wolfssl compatibility

  [ Helmut Grohne ]
  * New upstream version 1.4.56
  * Update debhelper compatibility level to 12.
    + Declare compatibility level via Build-Depends.
    + Add ${misc:Pre-Depends} to lighttpd for dh_installinit.
    + Accommodate moving documentation to /usr/share/doc/lighttpd.
  * consistently --link-doc all module packages

  [ Glenn Strauss ]
  * autopkgtests: upstream lighttpd integration tests

  [ Helmut Grohne ]
  * d/watch: Deal with %-escaped tilde
  * Stop supporting direct upgrades from squeeze

 -- Helmut Grohne <helmut.grohne@subdivi.de>  Wed, 09 Dec 2020 06:22:03 +0100

=== debian/control ===
--- 
+++ 
@@ -6,18 +6,17 @@
 Homepage: https://www.lighttpd.net/
 Build-Depends:
  dpkg-dev (>= 1.16.1~),
- debhelper (>= 10~),
+ debhelper-compat (= 12),
  mime-support,
  libmbedtls-dev,
  libnss3-dev,
  libssl-dev,
- libwolfssl-dev,
+ libwolfssl-dev (>= 4.2.0~),
  zlib1g-dev,
  libbrotli-dev,
  libpcre3-dev,
  default-libmysqlclient-dev | libmysqlclient-dev,
  libdbi-dev,
- libfam-dev,
  libldap2-dev,
  libfcgi-dev,
  libgdbm-dev,
@@ -54,6 +53,8 @@
  ${shlibs:Depends},
  mime-support,
  lsb-base (>= 3.0-6),
+Pre-Depends:
+ ${misc:Pre-Depends},
 Recommends:
  spawn-fcgi,
  perl:any,
@@ -387,5 +388,3 @@
 Package: lighttpd-mod-mbedtls
 Architecture: any
 Depends:
- ${misc:Depends},
- ${shlibs:Depends},

=== debian/tests/control ===
--- 
+++ 
@@ -8,3 +8,15 @@
 Tests: serve-static-file
 Depends: lighttpd, curl
 Restrictions: allow-stderr
+
+Tests: serve-cgi-file
+Depends: lighttpd
+Restrictions: allow-stderr
+
+Tests: do-not-emit-http-proxy-to-cgi
+Depends: lighttpd
+Restrictions: allow-stderr
+
+Tests: integration-tests
+Depends: lighttpd, lighttpd-mod-deflate, libfcgi-dev, perl, php-cgi
+Restrictions: allow-stderr, skip-not-installable
